$title(SIGNETICS Evaluation Board Routine)
$date(8-mar-89)
$pagewidth(132)
$mod751
$debug
$object
;this is the code that went to signetics,not complete but emulates the
;old evaluation board. With cont now initialized!!!!
;
;************************************************************************
;									*
;		This is the code for the SIGNETIC EVALUATION BOARD.	*
;		It is based on the code written	for the 		*
;		I2C EVALUATION BOARD 1987.				*
;									*
;		PHILIPS (NZ) LTD		G.D.MOSS		*
;									*
;************************************************************************
;	This driver will make the board perform like the i2c evaluation
;	board. There are conditional statements to enable it to assemble
;	for any of the microcontrollers on the board.
;INTERNAL RAM ORGANIZATION
;	Internal memory varies from controller to controller, as does
;	the special function registers that are present.
;	LOCATION	USE		COMMENTS
;	255				top of ram 87C552, 87C652
;	 :
;	 63				top of ram 87C751, 87C752
;	 :	     user ram
;	 :
;	 32				32 to 47 are bit addressable
;	 31
;	 :	     bank 3		free
;	 :	        8x8
;	 24
;	 23
;	 :	     bank 2		put the stack here
;	 :		8x8		8 levels deep
;	 16
;	 15
;	 :	     bank 1		used by I2C routines
;	 :		8x8
;	  8
;	  7
;	 :	     bank 0		for general use
;	 :		8x8		during programme
;	  0				operation
;
;SPECIAL FUNCTION REGISTERS
;	*	SFR that is bit addressable
;	#	SFR that is read only
;	-	SFR that is not on that chip
;	ADDRESS		87C51	87C552	87C652	87C751	87C752
;	  ffh		-	T3	-	-	-
;	  feh		-	PWMP	-	-	PWENA
;	  fdh		-	PWM1	-	-	-
;	  fch		-	PWM0	-	-	-
;	  f8h		-	IP1*	-	I2STA#	I2STA#
;	  f0h		B*	B*	B*	B*	B*
;	  efh		-	RTE	-	-	-
;	  eeh		-	STE	-	-	-
;	  edh		-	TMH2#	-	-	-
;	  ech		-	TML2#	-	-	-
;	  ebh		-	CTCON	-	-	-
;	  eah		-	TM2CON	-	-	-
;	  e8h		-	IEN1*	-	-	-
;	  e0h		ACC*	ACC*	ACC*	ACC*	ACC*
;	  dbh		-	S1ADR	S1ADR	-	-
;	  dah		-	S1DAT	S1DAT	-	-
;	  d9h		-	S1STA#	S1STA#	-	-
;	  d8h		-	S1CON*	S1CON*	I2CFG*	I2CFG*
;	  d0h		PSW*	PSW*	PSW*	PSW*	PSW*
;	  cfh		-	CTH3#	-	-	-
;	  ceh		-	CTH2#	-	-	-
;	  cdh		-	CTH1#	-	-	-
;	  cch		-	CTH0#	-	-	-
;	  cbh		-	CMH2	-	-	-
;	  cah		-	CMH1	-	-	-
;	  c9h		-	CMH0	-	-	-
;	  c8h		-	TM2IR*	-	-	-
;	  c6h		-	ADCH	-	-	-
;	  c5h		-	ADCON	-	-	-
;	  c4h		-	P5#	-	-	-
;	  c0h		-	P4*	-	-	-
;	  b8h		IP*	IP0*	IP*	-	-
;	  b0h		P3*	P3*	P3*	P3*	P3*
;	  afh		-	CTL3#	-	-	-
;	  aeh		-	CTL2#	-	-	-
;	  adh		-	CTL1#	-	-	-
;	  ach		-	CTL0#	-	-	-
;	  abh		-	CML2	-	-	-
;	  aah		-	CML1	-	-	-
;	  a9h		-	CML0	-	-	-
;	  a8h		IE*	IEN0*	IE*	IE*	IE*
;	  a0h		P2*	P2*	P2*	-	ADCON*
;	  99h		SBUF	S0BUF	S0BUF	I2DAT	I2DAT
;	  98h		SCON*	S0CON*	S0CON*	I2CON*	I2CON*
;	  90h		P1*	P1*	P1*	P1*	P1*
;	  8fh		-	-	-	-	PWMP
;	  8eh		-	-	-	-	PWCM
;	  8dh		TH1	TH1	TH1	RTH	RTH
;	  8ch		TH0	TH0	TH0	TH	TH
;	  8bh		TL1	TL1	TL1	RTL	RTL
;	  8ah		TL0	TL0	TL0	TL	TL
;	  89h		TMOD	TMOD	TMOD	-	-
;	  88h		TCON*	TCON*	TCON*	TCON*	TCON*
;	  87h		PCON	PCON	PCON	PCON	PCON
;	  84h		-	-	-	-	ADAT
;	  83h		DPH	DPH	DPH	DPH	DPH
;	  82h		DPL	DPL	DPL	DPL	DPL
;	  81h		SP	SP	SP	SP	SP
;	  80h		P0*	P0*	P0*	P0*	P0*
;
;DEFINE REGISTER USAGE
;	bank 0
;	R0	general purpose pointer into the ram
;	R1	points into transfer buffer
;	R2	loop counter,general purpose	
;	R3	general purpose			
;	R4	free				
;	R5	program control byte		
;		bits 1,0   4 mode counter
;	R6	switch data
;	R7	free
;
;	bank 1 for iic communications
;	R0	bit counter for 87c751/87c752 routine
;	R1	points into tbuff
;	R2	iic tx count
;	R3	iic rx count
;	R4	iic address
;	R5	iic loop counter
;	R6	free
;	R7	free
;
;THE SYSTEM CLOCK IS AT  11.059 MHz
;
;DEFINE CONSTANTS
true	equ	-1		;define "true"
false	equ	not true	;define "false"
c552	equ	false		;NOTE: only one of these to
c652	equ	false		;	be true at any
c751	equ	true		;	one time!!!
c752	equ	false		;
;
	if	c751 or c752
;redefine bits for i2con for mov instructions
bcxa	equ	80h
bidle	equ	40h
bcdr	equ	20h
bcarl	equ	10h
bcstr	equ	08h
bcstp	equ	04h
bxstr	equ	02h
bxstp	equ	01h
;redefine bits for i2cfg for mov instructions
bslaven	equ	80h
bmastrq	equ	40h
bclrti	equ	20h
btirun	equ	10h	
;misc constants for the 87c751/87c752
maxscl	equ	00000010b	;ct1,ct0 max xtal of 16MHz
intcon	equ	88h		;ea=1, ei2=0, et1=1, ex1=0, et0=0, ex0=0
	endif
;
;DEFINE INTERNAL DATA STORAGE
stack	data	16		;8 level stack, allow 2 register banks
cont	data	stack+16	;control 'register' bit addressable
clk1	data	cont+1		;clock 1, .10:.01 seconds
clk2	data	clk1+1		;clock 2,  10:1 seconds
clk3	data	clk2+1		;clock 3,  10:1 minutes
clk4	data	clk3+1		;clock 4,  10:1 hours
dat1	data	clk4+1		;clock 5,  10:1 days
dat2	data	dat1+1		;clock 6,  10:1 months
alm1	data	dat2+1		;clock 11, 10:1 minutes
alm2	data	alm1+1		;clock 12, 10:1 hours
mod1	data	alm2+1		;used by clock modify routine
mod2	data	mod1+1		;also used by clock modify routine
dtoa	data	mod2+1		;doa output value
keycnt	data	dtoa+1		;key input counter
tone	data	keycnt+1	;storage for dtmf tone
tbuff	data	tone+1		;transfer buffer for I2C operations
ebuff	data	tbuff+8		;eeprom buffer
free	data	ebuff+6		;first free location
;
	if	free gt 63	;keep below 87c751 limit
	out of internal memory
	endif
;
;DEFINE SFR BIT USAGE, FOR CONT REGISTER LOCATION MUST BE 20H !!
sdv	bit	0		;switch data valid
dmod	bit	1		;data modified
xmode	bit	2		;extra mode switch
aset	bit	4		;alarm is set flag
aring	bit	5		;alarm ringing flag
;
;IIC CHIP ADDRESSES
iop	equ	01001110b	;PCF8574
iopa	equ	01111110b	;PCF8574A
dtmf	equ	01001010b	;PCD3312
irtc	equ	01001100b	;SAA3028
led	equ	01110110b	;SAA1064
lcd	equ	01110100b	;PCF8577
atod	equ	10011110b	;PCF8591
clock	equ	10100010b	;PCF8583
ram	equ	10101110b	;PCF8570
eeprom	equ	10100110b	;PCF8582
;
;SERIAL I/O CLOCK FREQUENCY AND CONTROL BYTES
;
;IIC CHIP CONTROL BYTES
lcdctl	equ	00000000b	;lcd subaddress
ledctl	equ	01000111b	;initial led brightness value
clkctl	equ	00001100b	;clock control,masked,alarm active
alctl1	equ	11001001b	;alarm control,no clock alarm,timer
alctl2	equ	11011001b	;alarm control,clock daily alarm,timer
adcctl	equ	01000100b	;output on,4 inputs,inc,a/d channel 0
dacctl	equ	01000000b	;output on
;
;MISC CONSTANTS
dtmfb	equ	00111111b	;tone for second beep 1768Hz
dtmft	equ	00110101b	;first tone of alarm ringing 832Hz
dtmfo	equ	00000001b	;turns the dtmf oscillator off
keyval	equ	5		;number of key reads before valid
;
;
;THIS IS THE MAIN PROGRAMME.
	org	0000h
reset:	sjmp	start		;allow for all 87c552 interrupts
	org	0003h
xint0:	sjmp	reset	;trap external interrupt 0, 87C652, 87C751
	org	000bh
t0of:	sjmp	reset	;trap timer 0 overflow, 87C652, 87C751
	org	0013h
xint1:	sjmp	reset	;trap external interrupt 1, 87C652, 87C751
	org	001bh
t1of:	ajmp	tout	;trap timer 1 overflow, 87C652, 87C751
	org	0023h
uart:	sjmp	reset	;trap uart interrupt, 87C652
	org	002bh
i2c:	sjmp	reset	;trap i2c interrupt, 87C652
	org	0033h
t2ct0:	sjmp	reset	;trap t2 capture 0 interrupt
	org	003bh
t2ct1:	sjmp	reset	;trap t2 capture 1 interrupt
	org	0043h
t2ct2:	sjmp	reset	;trap t2 capture 2 interrupt
	org	004bh
t2ct3:	sjmp	reset	;trap t2 capture 3 interrupt
	org	0053h
adccom:	sjmp	reset	;trap adc completion interrupt
	org	005bh
t2cm0:	sjmp	reset	;trap t2 compare 0 interrupt
	org	0063h
t2cm1:	sjmp	reset	;trap t2 compare 1 interrupt
	org	006bh
t2cm2:	sjmp	reset	;trap t2 compare 2 interrupt
	org	0073h
t2of:	sjmp	reset	;trap timer 2 overflow
;
	org	0080h
;
;************************************************************************
;									*
;	Here is the initialization routine.				*
;	The first job is to put the I2C interface into the		*
;	slave receive mode at the speed set in the equate table.	*
;									*
;************************************************************************
;NOTE: some chips, inparticular large lcd drivers require some time
;to get ready before you write to them. You may want to alter the delay
;for your aplication.
;initialize iic interface
start:	mov	r0,#00h
	mov	r1,#20
	djnz	r0,$
	djnz	r1,$-2
	if	c552 or c652
	mov	p1,#p1init	;initialize the i/o port
	mov	s1con,#clkack	;sets up the iic hardware
	mov	ie,#00h		;turn off all the interupts
	endif	
	if	c751 or c752
	mov	i2cfg,#bslaven+maxscl+btirun
	mov	ie,#intcon	;interrupt control value
	endif
	mov	sp,#stack-1	;initialize stack pointer
	mov	r5,#00h		;set lcd,led mode time,seconds
	mov	r6,#00h		;clear old data
	mov	cont,#00h	;initialize control bits in sfr map
	mov	keycnt,#00h	;initialize key counter
	mov	tone,#dtmft	;initial tone value
;initialize clock /alarm control modes
	mov	tbuff,#00h	;word address to 0
	mov	tbuff+1,#clkctl	;clock control
	setb	rs0		;select register bank 1
	mov	r2,#02h		;tx = 2
	mov	r3,#00h		;rx = 0
	mov	r4,#clock	;address = clock
	acall	iic		;send control to clock
;no need to restore the register bank yet
	mov	tbuff,#08h	;word address to 8
	mov	tbuff+1,#alctl1	;alarm control, no clock alarm
	mov	r2,#02h		;tx = 2
	mov	r3,#00h		;rx = 0
	mov	r4,#clock
	acall	iic		;send alarm control to clock
;initialize the led brightness and operating mode
	mov	tbuff,#00h	;instruction to 0
	mov	tbuff+1,#ledctl
	mov	r2,#02		;tx = 2
	mov	r3,#00		;rx = 0
	mov	r4,#led		;address = led
	acall	iic
;now restore register bank
	clr	rs0		;select register bank 0
;
;This is the return point for the main loop
main:	acall	keytin		;get any key entry
	acall	rdclk		;get time/alarm data from clock
;now increment and output the dtoa value
dtoaop:	inc	dtoa		;increment output value
	mov	tbuff,#dacctl	;set digital control word
	mov	tbuff+1,dtoa	;output value
	setb	rs0		;select register bank 1
	mov	r2,#02		;tx = 2
	mov	r3,#00		;rx = 0
	mov	r4,#atod	;address = atod
	acall	iic
	clr	rs0		;select register bank 0
;now get and decode the switch data
swip:	jb	xmode,swipx	;exit as in modify mode
	jb	sdv,swip1	;test key valid flag and jump else
	sjmp	proc		;otherwise process display modes
swip1:	mov	a,r6		;get the switch data
	jb	acc.2,ledbr	;decrement the led brightness
	jb	acc.1,almtog	;toggle the alarm on/off
	jb	acc.0,lcdcnt	;alter lcd mode byte
swipx:	sjmp	proc
;
;LEDBR controls the led brightness.
;There are 8 steps of led current available. Depending on the
;characteristics of the led used some brightness steps might not be visable.
;The program limits the led brightness to 4 steps because of the above.
ledbr:	clr	sdv		;zero key valid flag 
	mov	keycnt,#00	;zero input counter
	mov	a,r4		;get old value
	add	a,#-10h		;decement
	mov	r4,a		;save new value
	anl	a,#30h		;limit values to 0 to 3
	mov	tbuff,#00	;instruction = 0
	add	a,#17h		;add 10h + led control bits
	mov	tbuff+1,a	;so output values 1 to 4
	setb	rs0		;select register bank 1
	mov	r2,#02		;tx = 2
	mov	r3,#00		;rx = 0
	mov	r4,#led		;address = led
	acall	iic		;write the led brightness value
	clr	rs0		;select register bank 0
	sjmp	proc		;done
;
;ALMTOG turns the alarm on if it was off and if it was off it 
;turns it on. It reverts the display to time so the alarm status
;can be seen.
almtog:	clr	sdv		;zero key valid flag
	mov	keycnt,#00	;zero key counter
	mov	a,r5
	anl	a,#00fh		;check mode
	jnz	almtx		;only turn alarm on if time displayed
	cpl	aset		;toggle alarm bit
	clr	aring		;make sure the alarm stops ringing
	mov	tbuff,#08h	;alarm control register
	mov	tbuff+1,#alctl2	;get ready to turn alarm on
	jb	aset,almt	;jump if turning alarm on
	mov	tbuff+1,#alctl1	;get ready to turn alarm off
almt:	setb	rs0		;select register bank 1
	mov	r2,#02
	mov	r3,#00
	mov	r4,#clock
	acall	iic		;send two bytes
	clr	rs0		;select register bank 0
	mov	tbuff,#dtmfo	;turn off any tone
	setb	rs0		;select register bank 1
	mov	r2,#01		;tx = 1
	mov	r3,#00		;rx = 0
	mov	r4,#dtmf	;address of dtmf
	acall	iic		;turn tone off
	clr	rs0		;select register bank 0
almtx:	sjmp	proc
;
;LCDCNT controls both the lcd and the led modes of display.
;The lcd has 4 modes	00 = clock(set)	01 = alarm(set)	
;			02 = date(set)	03 = A--d(display)
lcdcnt:	clr	sdv		;zero key valid flag
	mov	keycnt,#00	;zero input counter
	mov	a,r5		;get programme control byte
	inc	a
	anl	a,#0f3h		;2 bit counter, leave led brightness
	mov	r5,a		;put it back
lcdx:	sjmp	proc
;
;PROC processes the programme control byte
proc:	mov	a,r5		;get programme control byte
	anl	a,#0fh		;mask program mode
	acall	jlcd    	;decide where to jump
	jnb	aring,lcddis	;if alarm not ringing display normal
	mov	a,clk2		;get the seconds
	jb	acc.0,lcddis
;blank display if alarm ringing and seconds are odd
	mov	r1,#tbuff+4
	mov	r2,#04h
blank:	mov	a,@r1		;get non converted data
	anl	a,#20h		;leave the colon bit
	orl	a,#10h		;make it a blank
	mov	@r1,a		;put it back
	dec	r1
	djnz	r2,blank	;do all four characters
lcddis:	mov	tbuff,#lcdctl
	mov	dptr,#lcdtbl
	mov	r1,#tbuff+1
	mov	r2,#04h		;4 to encode
	acall	cnvrt		;change to displayable
	setb	rs0		;select register bank 1
	mov	r2,#05
	mov	r3,#00
	mov	r4,#lcd
	acall	iic		;send to display
	clr	rs0		;select register bank 0
	mov	a,r5		;get programme control byte
	anl	a,#0fh		;mask program mode
	acall	jled		;decide where to jump
	mov	tbuff,#01h	;led instruction address 01
	mov	dptr,#ledtbl
	mov	r1,#tbuff+1
	mov	r2,#04h		;4 to encode
	acall	cnvrt		;change it to displayable
	setb	rs0		;select register bank 1
	mov	r2,#05h
	mov	r3,#00
	mov	r4,#led
	acall	iic		;to display
	clr	rs0		;select register bank 0
	mov	r0,#0ffh	;this delay alters keyboard response
	mov	r1,#04fh	;and dtoa ramp rate
delay:	djnz	r0,delay
	djnz	r1,delay
	ajmp	main
;
;************************************************************************
;									*
;	The flow of data from the peripheral devices to the		*
;	displays is controlled by the low nibble stored in register R5	*
;	JLCD directs the programme to the lcd routines.			*
;	JLED directs the programme to the led routines.			*
;	NOTE this must be called so that each display processor		*
;	will return to PROC.						*
;									*
;************************************************************************
;
jlcd:	mov	dptr,#jmplcd
	rl	a
	jmp	@a+dptr
jled:	mov	dptr,#jmpled
	rl	a
	jmp	@a+dptr
;
;  short jumps
jmplcd:	ajmp	clkp
	ajmp	almp
	ajmp	datp
	ajmp	atodp
;
jmpled:	ajmp	secp
	ajmp	secp
	ajmp	secp
	ajmp	dtoap
;
atodp:	jb	xmode,atodm	;jump to xmode routine
;Check to see if button 4 has been pressed etc.
atodp0:	jnb	sdv,atodpd	;jump if buttons not valid
	mov	a,r6		;get key data
	jnb	acc.3,atodpd	;jump if not button 4
	clr	sdv		;zero flag so that only 1 keypress
	mov	keycnt,#00h	;zero input counter
	setb	xmode		;turn on xmode bit
atodpd:	mov	tbuff+1,#00ah	;A
	mov	tbuff+2,#017h	;-
	mov	tbuff+3,#017h	;-
	mov	tbuff+4,#00dh	;d
	ret
atodm:	jnb	sdv,atodm1	;test if valid button, jump if not
	clr	sdv		;zero flag so that only 1 keypress
	mov	keycnt,#00h	;zero input counter
	clr	xmode		;zero extra mode
	mov	r5,#00h		;lcd = time led = seconds
atodm1:	mov	tbuff,#adcctl	;set analogue control word
	setb	rs0		;select register bank 1
	mov	r2,#01		;tx = 1
	mov	r3,#01		;rx = 1
	mov	r4,#atod	;address = atod
	acall	iic
	clr	rs0		;select register bank 0
	mov	a,tbuff		;get data
	mov	tbuff+1,#10h	;blank
	mov	r0,#tbuff+3
	acall	htod		;convert to bcd
	ret			;done
dtoap:	mov	a,dtoa		;get byte
	mov	tbuff+1,#10h	;a blank
	mov	r0,#tbuff+3	;point to where the 10's digit is to go
	acall	htod		;convert to decimal
	ret
;
;ROMWR write to the PCF8582 eeprom chip.
;Due to the added complexity of the eeprom write routine,any data
;to be transfered is loaded into a special buffer.This buffer is
;10 bytes long but could be made longer by altering the equate table.
;The first byte in the buffer are the number of data bytes.The next
;byte is the internal word address and the rest of the buffer,upto 8
;bytes,is filled with data for consecutive memory locations in the chip.
;The PCB8582 takes 30ms to process each written byte.
;If the PCB8582 is still busy processing the last data written to it,
;it will not acknowledge its write address so the routine will exit
;without altering the buffer contents.If it is sucessful in writing
;upto 2 bytes to the chip then the buffer contents will be altered to
;reflect this fact.
;On exit,the first byte in the buffer will be the number of bytes
;still to be sent.This will be zero when the buffer is free.
;The second byte is the address of the next memory location to be written
;to.The buffer data contents are moved to the start of the buffer ready 
;for the next time the routine is used.
romwr:	mov	r0,#ebuff	;point to eeprom buffer
	mov	r1,#tbuff	;point to transfer buffer
	mov	r2,#00h		;number sent counter
	mov	a,@r0		;get the number to send
	jz	romwrx		;exit if none left to send
	mov	r3,a		;save the number to send
	inc	r0		;point to word address
	mov	a,@r0		;get the word address
	mov	@r1,a		;put word address into buffer
	inc	r0		;point to 1st data byte
	inc	r1
	mov	a,@r0		;get 1st data byte
	mov	@r1,a		;put 1st data byte
	inc	r2		;up the number sent counter
	dec	r3		;down the number to send counter
	mov	a,r3
	jz	romwrs		;only 1 to send
	inc	r0
	inc	r1
	mov	a,@r0		;get 2nd data byte
	mov	@r1,a		;put 2nd data byte
	inc	r2
	dec	r3
romwrs:	mov	a,r2		;get the number to send
	inc	a		;make allowance for word address
	setb	rs0		;select register bank 1
	mov	r2,a		;tx = accu+1
	mov	r3,#00h		;rx = 0
	mov	r4,#eeprom	;set the address
	acall	iic
	clr	rs0		;select register bank 0
jnz	romwrx		;none zero is a failure
	mov	r1,#ebuff	;point to start of ebuff
	mov	a,r3		;get new number to send
	mov	@r1,a		;save it for next time
	inc	r1		;point to word address
	mov	a,@r1		;get the old address
	add	a,r2		;add in the number sent
	mov	@r1,a		;save it for next time
romwrm:	inc	r1		;point to first data byte
	inc	r0		;point to first non sent byte
	mov	a,r3		;get number to send/move
	jz	romwrx		;if zero exit
	mov	a,@r0
	mov	@r1,a
	dec	r3
	sjmp	romwrm		;jump back more to move
romwrx:	ret			;done until next time
;
;************************************************************************
;		THESE ARE THE IIC I/O ROUTINES ONLY			*
;		THEY EMULATE THE ROUTINES USED ON THE 1987		*
;		EVALUATION BOARD.AT THIS TIME THESE ARE NOT		*
;		PROVEN ON HARDWARE.					*
;************************************************************************
;									*
;	SERIAL INTERFACE SOFTWARE ROUTINES				*
;	ACCESSED BY	call	iic					*
;	REGISTER BANK 1 WILL BE USED EXCLUSIVELY FOR SIO ROUTINES	*
;	REGISTER USAGE							*
;	R'0	USED BY 87C751 AS A BIT COUNTER				*
;	R'1	POINTS TO THE TX/RX BUFFER				*
;	R'2	HOLDS THE NUMBER TO TRANSMIT				*
;	R'3	HOLDS THE NUMBER TO RECEIVE				*
;	R'4	SLAVE ADDRESS R/W BIT = 0				*
;	R'5	TX/RX COUNTER						*
;									*
;************************************************************************
;	8 DATA BYTES IS THE MAXIMUM THAT CAN BE SENT OR RECIEVED	*
;	THIS IS DUE TO THE SIZE OF TBUFF BUT CAN BE EASILY ALTERED	*
;	ON ENTRY:							*
;		R'2	NUMBER OF BYTES TO TX				*
;		R'3	NUMBER OF BYTE TO RX				*
;		R'4	SLAVE ADDRESS					*
;	ON EXIT:							*
;		ACCU	00 IF TRANSFER OK				*
;			01 IF NOT ACKNOWLEDGED				*
;			FF IF A BUS ERROR OCCURED			*
;		R'1	POINTS TO LAST READ BYTE			*
;									*
;************************************************************************
;
;
	if	c552 or c652
;************************************************************************
;									*
;	TRIAL I2C ROUTINES FOR THE 80C552/652 DEVICES			*
;		Incoperating corrections from G.W.DUMBLETON		*
;		His corrections are in upper case to make them		*
;		easily seen, but some of them I feel are in fact	*
;		not required.This will be tested when I have some 	*
;		hardware to play with.					*
;									*
;			24th NOVEMBER 1987				*
;									*
;		PHILIPS (NZ) LTD		G.D.MOSS		*
;									*
;************************************************************************
iic:	mov	r1,#tbuff
	mov	s1con,#clkack	;reset sio status
;generate the address with the rd/wr bit correctly set
	mov	a,r2		;get tx count
	jz	rdadd		;r/w = 0
	mov	a,#01h		;set for rx
rdadd:	orl	a,r4		;get address
	xrl	a,#01h		;invert rd wr bit
;	mov	s1dat,a		;load address to send
	MOV	R7,A		;TEMP SAVE WHY NOT IN THE DATA REGISTER
	setb	sta		;generate a start condition
	sjmp	wsi1		;wait for si = 1,status should be 08h
;the bus was not busy and a valid start condition was generated 08h
iics:	CLR	STA		;SO WE DON'T GENERATED REPEATED STARTS
	MOV	A,R7		;THIS SHOULD NOT BE REQUIRED
	MOV	S1DAT,A		;BUT WE WILL SEE WITH SOME HARDWARE
	clr	si		;this will now transmit the address
	sjmp	wsi1		;wait for si = 1,status 18h 20h 40h 48h
;the bus was freed and a restart was generated 10h
iicrs:	CLR	STA		;NOT REPEATED REPEATED STARTS
	mov	a,r4		;get the address
	orl	a,#01h		;make it a read
	mov	s1dat,a		;ready it for sending
	clr	si		;send the address on its way
	sjmp	wsi1		;wait for si = 1,status 40h 48h
;now in master tx mode so tx first byte 18h
mtxa:	mov	a,r2		;get the number to send
	mov	r5,a		;load the tx counter with it
	mov	a,@r1		;get data to send
	mov	s1dat,a		;put it where it will be sent from
	clr	si		;send it on its way
	sjmp	wsi1		;wait for si = 1,status 28h 30h
;in master tx mode see if any more to tx 28h
mtxd:	djnz	r5,mtxd1	;jump if multiple bytes to send
	mov	a,r3		;get number to read
	jz	stopok		;none so stop
	setb	sta		;generate a repeated start
	CLR	SI		;START THE REPEATED START
	sjmp	wsi1		;wait for si = 1,status 10h
mtxd1:	inc	r1		;point to next byte to send
	mov	a,@r1
	mov	s1dat,a		;ready it for sending
	clr	si
	sjmp	wsi1		;wait for si = 1,status 28h 30h
;read address sent and device acknowledged,read first byte 40h
mrxa:	mov	r1,#tbuff	;point to buffer
	mov	a,r3		;get receiver count
	mov	r5,a		;load the counter with it
	djnz	r5,rdmlti	;jmup if more than 1 byte to read
rdlast:	clr	aa		;set interface to not acknowledge
rdmlti:	clr	si		;start it on its way
	sjmp	wsi1		;wait for si = 1,status 50h 58h
;read multiple bytes until its the last byte 50h
mrxd:	mov	a,s1dat		;get the received byte
	mov	@r1,a		;put it into tbuff
	inc	r1		;point to next
	djnz	r5,rdmlti	;loop back to read more
	sjmp	rdlast		;read the last with no acknowledge
;the last byte will be not acknowledged 58h
mrxna:	mov	a,s1dat		;get the last byte
	mov	@r1,a		;put it into tbuff
stopok:	clr	a		;return the accu = 00
	setb	aa		;set acknowledge bit
stop:	setb	sto		;issue a stop
	CLR	SI		;START A STOP
	ret			;iic routine finished so return
;if the addressed device doesn't acknowledge we get here 20h 30h 48h
noack:	mov	a,#01h		;return the accu = 01
	sjmp	stop		;issue a stop and exit
;if something fatal happened we get here  00h
buserr:	clr	ensi		;turn off the i2c bus
	mov	p1,#p1init	;reinitialize port p1
	mov	s1con,#clkack	;re-initialize i2c control register
	mov	a,#0ffh		;return with accu = ff
	ret			;done
;
wsi1:	jnb	si,$		;jump here until si = 1
	mov	a,s1sta		;get the status
	rr	a
	rr	a
	mov	dptr,#iictbl	;point to the table
	jmp	@a+dptr
iictbl:	ajmp	buserr
	ajmp	iics
	ajmp	iicrs
	ajmp	mtxa
	ajmp	noack
	ajmp	mtxd
	ajmp	noack
	ajmp	buserr
	ajmp	mrxa
	ajmp	noack
	ajmp	mrxd
	ajmp	mrxna
;
	endif
;
	if	c751 or c752
;****************************************************************
;		THE IIC ROUTINE FOR THE 87C751			*
;****************************************************************
iic:	mov	r0,#00h		;start timer
	mov	r1,#tbuff
	mov	i2dat,#80h
	clr	ei2		;disable i2c interrupt
	mov	i2cfg,#bmastrq+maxscl+btirun
ifstrt:	jb	str,sndaddr	;if start then send address
	jb	arl,lostarb	;jump if we lost arbitration
	djnz	r0,ifstrt	;try again
	ajmp	tout		;could not get on bus (approx 1.5mS)
sndaddr:
	mov	a,r2		;get tx count
	jz	rdadd		;r/w = 0
	mov	a,#01h		;set for tx
rdadd:	orl	a,r4		;or in the address
	xrl	a,#01h		;set correct r/w polarity, correct addr in acc
	mov	i2con,#bcarl+bcstr+bcstp	;release scl
	acall	i2xmtb		;send 8, wait for ack
	jnb	drdy,mfault	;IIC fault? (arl/str/stp)
	jb	rdat,mxnoack	;no ack so jump
;address byte has been sent with no errors
	mov	a,r2		;get the tx count
	jnz	write		;some bytes to write
read:	mov	a,r3		;get rx count
	jz	mxstop		;non to rx so stop
	mov	r5,a		;save rx count in loop counter
	mov	a,r2		;get tx count
	jz	read1		;don't retransmit the address
	mov	i2con,#bcdr+bxstr	;send a repeated start
	jnb	atn,$		;wait for atn
	mov	i2con,#bcdr	;clear useless drdy
	jnb	atn,$		;wait for atn, arl/str/stp
	jb	arl,lostarb	;go if lost arb
	mov	r1,#tbuff	;point to transfer buffer
	mov	a,r4		;get address
	setb	acc.0		;set read mode
	mov	i2con,#bcarl+bcstr+bcstp	;release scl
	acall	i2xmtb		;send address wait for ack
	jnb	drdy,mfault	;go if fault
read1:	acall	i2rcv8		;recieve a byte but not the ack bit
	sjmp	readck		;only one byte to rx
;read byte(s)
readlp:	acall	i2sar8		;send ack then recieve byte
readck:	jnb	drdy,mfault
	mov	@r1,a		;store the byte
	inc	r1		;up the pointer
	djnz	r5,readlp	;loop if more needed
;recieved the required number of bytes now send nack
	mov	i2dat,#80h	;send nack=1
	jnb	atn,$		;wait for atn
	jnb	drdy,mfault
	sjmp	mxstop		;go stop ok
; write byte(s) to slave
write:	mov	a,r2		;set write loop counter
	mov	r5,a
mxlp:	mov	a,@r1		;get byte to send
	inc	r1		;point to next
	acall	i2xmtb		;send a byte, wait for ack
	jnb	drdy,mfault	;IIC fault?
	jb	rdat,mxnoack	;jump if slave no ack'ed
	djnz	r5,mxlp		;loop if more to send
	sjmp	read		;normal stop or repeated start
lostarb:
	setb	slaven		;re-enable slave mode
	mov	i2con,#bcarl+bcstp+bcstr+bcxa	;+bidle	idle slave set
			;enable iic interrupt here
	mov	a,#0ffh		;return error code
	ret
mxnoack:
	mov	a,#01h		;return code for nack
	sjmp	stop
mfault:	jb	arl,lostarb	;this master lost arbitration
	mov	a,#0ffh		;return error code
	sjmp	stop
mxstop:	mov	a,#00		;return 0 if all ok
stop:	clr	mastrq		;dont keep master mode
	mov	i2con,#bcdr+bxstp	;generate iic stop
	jnb	atn,$		;wait for atn
	mov	i2con,#bcdr	;clear useless drdy
	jnb	atn,$		;wait for stp
	setb	slaven		;keep iic interface active
	mov	i2con,#bcarl+bcstp+bcstr+bcxa	;clear iic int= atn flag
			;enable iic interrupt here
	ret
;
;If iic timer overflows we get here.
tout:;	db	0a5h,00h		;reserved
	mov	i2cfg,#bclrti	;clear iic timeout int flag
	clr	ea
	acall	xreti
;
toggle:	setb	p0.1		;sda = 1
	cpl	p0.0		;toggle scl
	db	00,00,00,00,00	;5uS wait
	jnb	p0.1,toggle	;jump if sda not free
	jnb	p0.0,toggle	;jump if scl not 1
	clr	p0.0		;scl = 0
	clr	p0.1		;sda = 0
	db	00,00,00	;total 5uS
	setb	p0.0		;scl = 1
	db	00,00,00,00,00	;5uS wait
	setb	p0.1		;sda = 1    STOP!!!
	mov	ie,#intcon	;interrupt control value
	mov	sp,#stack-1	;reset stack
	mov	i2cfg,#bslaven+btirun+maxscl
	clr	rs0		;revert to bank 0
	clr	rs1
	ajmp	main
;
;*********************************************************************
;		subroutines for the iic routine
;*********************************************************************
;
xreti:	reti			;clear interrupt flag
;
;send ack = 0 then receive 8 bits
i2sar8:	mov	i2dat,#0	;send ack
	jnb	atn,$		;wait for atn
	jnb	drdy,i2rcvr	;go if iic fault
;receive 8 bits
i2rcv8:	mov	r0,#8		;bits to be received in loop
i2rcv8a:
	clr	a		;clear the byte accumulator
rbitlp:	orl	a,i2dat		;include the bit, clear atn
rbitrl:	rl	a		;data comes in at msb
	jnb	atn,$		;wait for atn
	jnb	drdy,i2rcvr	;go if iic fault
	djnz	r0,rbitlp	;loop if not 7 bits yet
	mov	c,rdat		;get the 8th bit but don't clear atn
	rlc	a		;include the 8th bit
i2rcvr:	ret			;done
;iic master transmit, send 8 bits and wait for ack
i2xmtb:	mov	r0,#8		;start bit count
xbitlp:	mov	i2dat,a		;set xmit mode, send bit
xbitrl:	rl	a		;spin the byte
	jnb	atn,$		;wait for attention
	jnb	drdy,xmt8r	;jump if fault
	djnz	r0,xbitlp	;loop if not all out
; switch to rx mode for ack bit
	mov	i2con,#bcdr+bcxa
	jnb	atn,$		;wait for ack
xmt8r:	ret
;
	endif
;
;
;KEYTIN tests the validity of a keypress, and if it has been held for the
;required time sets the valid flag. The programme uses the valid flag
;to know that there is data to process. When finished for 1 press clear
;the valid flag and the counter, keyin will clear old data when the key
;is released. For auto repeating input clear the valid flag, the counter
;and old data.
;Key data could come from a scan matrix routine or infra red link.
;	R6 holds the old data, R7 bit 1 is the valid flag
;	keycnt is the counter, keyval is the loop count maximum
keytin:	setb	p1.0		;trigger for scope
	setb	rs0		;select register bank 1
	mov	r2,#00h
	mov	r3,#01h
	mov	r4,#iopa
	acall	iic		;read the 4 pushbuttons
	clr	rs0		;select register bank 0
	clr	p1.0
	mov	a,tbuff		;get data
	cpl	a		;invert the data
	anl	a,#0fh		;mask the switches
	mov	r3,a		;save temporary (new)
	jz	keyt0		;no data
;valid data is in r3 test if first detection
keyt:	mov	a,r6		;test if old data
	jz	keyt1		;equals zero, jump if does
;	jb	sdv,keytx	;if key not used on last pass exit
;now test if auto repeat or 1 press
	mov	a,keycnt	;get counter
	jz	keytx		;1 press allowed so exit
	mov	a,r3		;get new
	xrl	a,r6		;compare with old
	jnz	keytx		;not the same so exit
	inc	keycnt		;up the counter by 1
keytc:	mov	a,keycnt	;get the counter
	xrl	a,#keyval	;compare with loop maximum
	jnz	keytx		;more loops to do
	setb	sdv		;turn on valid flag
;common exit point, could be a ret if this was a subroutine.
keytx:	ret
keyt0:	mov	r6,#00h		;clear old
	mov	keycnt,#00h	;clear counter
	clr	sdv		;clear valid flag
	sjmp	keytx		;done now exit
;if this is the first detected press of the key
keyt1:	mov	a,r3		;get new
	mov	r6,a		;save it in r6
	inc	keycnt		;up the counter for the first time
	sjmp	keytx		;now exit
;
;
;RDCLK will read all the relevant data required from the clock chip.
;The time is stored in clk1-clk4.
;If the alarm is to ring it sell set the alarm ringing flag and clear
;the alarm flag in the chip.
;This routine could be extended to read the date and alarm time so that
;you get everything in one go.
rdclk:	mov	tbuff,#00h	;set word address to 00
	setb	rs0		;select register bank 1
	mov	r2,#01h		;tx = 1
	mov	r3,#05h		;rx = 5
	mov	r4,#clock	;address = clock
	acall	iic		;from the clock
	clr	rs0		;select register bank 0
	setb	f0		;use f0 as a flag
	mov	a,clk2		;get old seconds
	cjne	a,tbuff+2,beepj	;compare old with new jump if not equal
	clr	f0
;move the time to it's storage area
beepj:	mov	r0,#clk1	;point to where we will keep it
	mov	r1,#tbuff+1	;the source
	mov	r2,#04h		;to move 4 bytes
rdclk1:	mov	a,@r1		;get
	mov	@r0,a		;put
	inc	r1
	inc	r0		;**** could make this a subroutine
	djnz	r2,rdclk1	;loop
;now look at the status word and test for alarm ring.
	mov	a,tbuff		;get status
	jnb	acc.1,rdclkx	;not set so exit via beep if needed
;now set the alarm ringing flag and clear the flag in the chip
	setb	aring		;make the alarm ring
	mov	tbuff,#00h	;control word address
	mov	tbuff+1,#clkctl	;control word
	setb	rs0		;select register bank 1
	mov	r2,#02h		;tx = 2
	mov	r3,#00h		;rx = 0
	mov	r4,#clock	;address for clock
	acall	iic
	clr	rs0		;select register bank 0
;if a new second jump to beep
rdclkx:	jb	f0,beep		;jump else return
	ret
;
;BEEP ckecks the seconds and outputs a tone accordingly.
;If seconds = 00 turns on minute beep, if seconds = 01 turns off beep.
;if the alarm is running it plays a melody.
;
beep:	jb	aring,ring	;if ringing jump
	mov	a,clk2		;get seconds
	jnz	sec01		;not 00 go test if 01
	mov	tbuff,#dtmfb	;is zero so tone for seconds beep
beepop:	setb	rs0		;select register bank 1
	mov	r2,#01h		;tx = 1 always send 1
	mov	r3,#00h		;rx = 0
	mov	r4,#dtmf	;address = dtmf
	acall	iic		;call the general interface
	clr	rs0		;select register bank 0
beepx:	ret			;done
sec01:	cjne	a,#01h,beepx	;exit if not 01
beepof:	mov	tbuff,#dtmfo	;dtmf off value
	sjmp	beepop		;output it
ring:	mov	a,clk2		;get the seconds
	cjne	a,#10h,ringx	;exit if not 10
	clr	aring		;turn off alarm ringing flag
	mov	tone,#dtmft	;first tone value-1
	sjmp	beepof
ringx:	inc	tone		;increment tone value
	mov	tbuff,tone	;move tone to buffer
	sjmp	beepop		;output it
;
;HTOD converts the byte in the accu into 3 unpacked bcd numbers.
;On entry r0 points to where the tens digit is to be stored.
;The hundreds go in r0-1 and the units in r0+1.
;Register usage	r0	points to tens and units
;		r1	points to hundreds
htod:	xch	a,r0		;get tens pointer
	mov	r1,a		;hundreds point to tens
	xch	a,r0		;r0 points to tens
	dec	r1		;r1 points to hundreds
;registers set up now do the convertion
	mov	b,#100		;devide by 100
	div	ab		;to determine hundreds
	mov	@r1,a		;save hundreds
	mov	a,#10		;devide remainder by 10
	xch	a,b
	div	ab		;10's in acc, remainder in b
	mov	@r0,a		;save 10's
	mov	a,b		;get 1's
	inc	r0
	mov	@r0,a		;save 1's
	ret
;
;SPLIT takes the data pointed to by R0 and R0+1 and splits the nibbles
;up.They are stored in the ram pointed to by R1,R1-1,R1-2 and R1-3.
split:	mov	a,@r0
	anl	a,#0fh
	mov	@r1,a		;units
	dec	r1
	mov	a,@r0
	swap	a
	anl	a,#0fh
	mov	@r1,a		;tens
	inc	r0
	dec	r1
	mov	a,@r0
	anl	a,#0fh
	mov	@r1,a		;hundreds
	dec	r1
	mov	a,@r0
	swap	a
	anl	a,#0fh
	mov	@r1,a		;thousands
	ret			;return to display
;
;CNVRT converts a 6 bit code,pointed to by R1,and
;returns with a byte to send to either the LCD or the LED
;stored in the location pointed to by R1.
;	bits 4-0	define one of 32 characters
;	bit  5		controls the colon
;	R0		points to conversion table (lcd or led)
;	R1		points to character string to convert
;	R2		character count to convert (normally 4)
;	R3		temporary storage of colon information
lcda	equ	80h		;lcd segment a
lcdb	equ	40h		;lcd segment b
lcdc	equ	20h		;lcd segment c
lcdd	equ	10h		;lcd segment d
lcde	equ	08h		;lcd segment e
lcdf	equ	04h		;lcd segment f
lcdg	equ	02h		;lcd segment g
lcdh	equ	01h		;lcd segment h colon
;
leda	equ	04h		;led segment a
ledb	equ	08h		;led segment b
ledc	equ	40h		;led segment c
ledd	equ	20h		;led segment d
lede	equ	10h		;led segment e
ledf	equ	01h		;led segment f
ledg	equ	02h		;led segment g
ledh	equ	80h		;led segment h colon
;
cnvrt:	mov	r3,#00		;set colon off
	mov	a,@r1		;get character
	jb	acc.5,colon	;jump if colon to set on
cnvrt1:	movc	a,@a+dptr	;get value from the table
	orl	a,r3		;or in colon
	mov	@r1,a		;overwrite input character
	inc	r1		;point to next
	djnz	r2,cnvrt	;loop counter
cnvrtx:	ret			;done
colon:	mov	a,#20h		;colon location in table
	movc	a,@a+dptr	;get
	mov	r3,a		;save
	mov	a,@r1		;get again
	anl	a,#1fh		;mask
	sjmp	cnvrt1
;
lcdtbl:	db	lcda+lcdb+lcdc+lcdd+lcde+lcdf		;0
	db	lcdb+lcdc				;1
	db	lcda+lcdb+lcdg+lcde+lcdd		;2
	db	lcda+lcdb+lcdg+lcdc+lcdd		;3
	db	lcdf+lcdg+lcdb+lcdc			;4
	db	lcda+lcdf+lcdg+lcdc+lcdd		;5
	db	lcda+lcdf+lcdg+lcde+lcdd+lcdc		;6
	db	lcda+lcdb+lcdc				;7
	db	lcda+lcdb+lcdc+lcdd+lcde+lcdf+lcdg	;8
	db	lcda+lcdb+lcdf+lcdg+lcdc+lcdd		;9
	db	lcda+lcdb+lcdf+lcdg+lcdc+lcde		;A
	db	lcdc+lcdd+lcde+lcdf+lcdg		;b
	db	lcda+lcdd+lcde+lcdf			;C
	db	lcde+lcdg+lcdd+lcdc+lcdb		;d
	db	lcda+lcdd+lcde+lcdf+lcdg		;E
	db	lcda+lcde+lcdf+lcdg			;F
	db	0					;blank
	db	lcda					;segment a
	db	lcdb					;segment b
	db	lcdc					;segment c
	db	lcdd					;segment d
	db	lcde					;segment e
	db	lcdf					;segment f
	db	lcdg					;segment g
	db	lcdb+lcdc+lcde+lcdf+lcdg		;H
	db	lcdd+lcde+lcdf				;L
	db	lcda+lcdb+lcdf+lcdg			;degree
	db	lcdc+lcdd+lcde+lcdg			;lower degree
	db	0					;spare
	db	0					;spare
	db	0					;spare
	db	0					;spare
	db	lcdh					;colon
;
ledtbl:	db	leda+ledb+ledc+ledd+lede+ledf		;0
	db	ledb+ledc				;1
	db	leda+ledb+ledg+lede+ledd		;2
	db	leda+ledb+ledg+ledc+ledd		;3
	db	ledf+ledg+ledb+ledc			;4
	db	leda+ledf+ledg+ledc+ledd		;5
	db	leda+ledf+ledg+lede+ledd+ledc		;6
	db	leda+ledb+ledc				;7
	db	leda+ledb+ledc+ledd+lede+ledf+ledg	;8
	db	leda+ledb+ledf+ledg+ledc+ledd		;9
	db	leda+ledb+ledf+ledg+ledc+lede		;A
	db	ledc+ledd+lede+ledf+ledg		;b
	db	leda+ledd+lede+ledf+ledg		;C
	db	lede+ledg+ledd+ledc+ledb		;d
	db	leda+ledd+lede+ledf+ledg		;E
	db	leda+lede+ledf+ledg			;F
	db	0					;blank
	db	leda					;segment a
	db	ledb					;segment b
	db	ledc					;segment c
	db	ledd					;segment d
	db	lede					;segment e
	db	ledf					;segment f
	db	ledg					;segment g
	db	ledb+ledd+lede+ledf+ledg		;H
	db	ledd+lede+ledf+ledg			;L
	db	leda+ledb+lede+ledf+ledg		;degree
	db	ledc+ledd+lede+ledg			;lower degree
	db	0					;spare
	db	0					;spare
	db	0					;spare
	db	0					;spare
	db	ledh					;colon
;
;CLKP displays the present clock time
;If button 4 has been pressed set up for modify mode by moving the
;current time, setting the mod bit in r5 and zeroing the keyvalid flag
;to indicate that the key has been used.
clkp:	jb	xmode,clkm	;jump if bit set to the modify routine
;Check to see if button 4 has been pressed etc.
clkp0:	jnb	sdv,clkpd	;jump if no valid button press
	mov	a,r6		;get key data
	jnb	acc.3,clkpd	;jump if not button 4
	clr	sdv		;zero flag so that only 1 key press
	mov	keycnt,#00h	;zero input counter
	setb	xmode		;turn on mod bit
;Move the current hours and minute to the modify data area.
	mov	mod1,clk3	;move minutes
	mov	mod2,clk4	;move hours
;now get ready to display the current time
clkpd:	mov	a,clk2		;get seconds
	mov	r3,a		;save it for flash duration
	mov	r0,#clk3	;point to minutes
	mov	r1,#tbuff+4
	acall 	split		;separate them for display
	jnb	aset,clkp1	;jump if alarm not set
	xrl	tbuff+3,#20h	;turn on the alarm colon
clkp1:	mov	a,r3		;get unit seconds
	jb	acc.0,clkpx	;flash double colon on even seconds
	xrl	tbuff+1,#20h	;turn on the tens hour colon
clkpx:	ret			;return to display
;
;CLKM modifies the time
clkm:	acall	modt		;call the modify time routine
	jnb	sdv,clkmx1	;switches not valid so exit
	mov	a,r6		;get the switch data
	jz	clkmx		;jump if switch 2 or 3 were pressed
	jnb	acc.0,clkmx0	;exit if button 1 not pressed
	jb	dmod,clkme	;jump to enter new clock data
	clr	xmode
	mov	r5,#00h		;lcd = time  led = seconds
	sjmp	clkmx0		;exit but only allow 1 entry
clkmx:	mov	r6,#00h		;zero the switch data
clkmx0:	clr	sdv		;zero the key valid flag
	mov	keycnt,#00h	;zero the key counter
clkmx1:	mov	r0,#mod1
	mov	r1,#tbuff+4
	acall	split		;splits packed bcd for display
	orl	tbuff+1,#20h	;turn on colon
	ret			;return and display
clkme:	mov	tbuff,#01h	;word address to 1
	mov	tbuff+1,#00	;hundredths to 0
	mov	tbuff+2,#00	;seconds to 0
	mov	tbuff+3,mod1	;minutes
	mov	tbuff+4,mod2	;hours
	setb	rs0		;select register bank 1
	mov	r2,#05h		;tx = 5
	mov	r3,#00		;rx = 0
	mov	r4,#clock	;address = clock
	acall	iic		;to the clock
	clr	rs0		;select register bank 0
	clr	sdv		;zero the key valid flag
	mov	keycnt,#00h	;zero key counter
	clr	xmode
	clr	dmod
	mov	r5,#00h		;lcd = time  led = seconds
	sjmp	clkmx1
;
;SECP displays the present number of seconds
secp:	mov	a,clk2		;get seconds
	mov	b,#16		;devide by 16
	div	ab		;units in b, ten's in acc
	mov	tbuff+1,#17h	;a dash
	mov	tbuff+2,a	;ten seconds
	mov	tbuff+3,b	;unit seconds
	mov	tbuff+4,#17h	;another dash
	ret			;return to display
;
;ALMP displays the current alarm status or jumps to alarm modify
almp:	jb	xmode,almm	;jump if bit set to alarm modify
;get the data that we will display
almp0:	mov	tbuff,#0bh	;word address for alarm
	setb	rs0		;select register bank 1
	mov	r2,#01h
	mov	r3,#02h
	mov	r4,#clock
	acall	iic		;from the clock
	clr	rs0		;select register bank 0
	mov	alm1,tbuff
	mov	alm2,tbuff+1
;Check to see if button 4 has been pressed etc.
	jnb	sdv,almpd	;jump if buttons not valid
	mov	a,r6		;get key data
	jnb	acc.3,almpd	;jump if not button 4
	clr	sdv		;zero flag so that only 1 key press
	mov	keycnt,#00h	;zero input counter
	setb	xmode		;turn on mod bit
;Move the current alarm time to the modify data area.
	mov	mod1,alm1
	mov	mod2,alm2
;now get ready to display the alarm time
almpd:	mov	r0,#alm1
	mov	r1,#tbuff+4
	acall	split
	mov	r1,#tbuff+4	;less bytes to do this
	mov	r2,#04h		;this as a loop
almpc:	mov	a,@r1
	orl	a,#20h		;colon on
	mov	@r1,a
	dec	r1		;point to next
	djnz	r2,almpc
almpx:	ret			;return to display
;
;ALMM modifies the alarm time.The time to modify is is mod1 and mod2.
;Mod1 holds the minutes and mod2 holds the hours.
;It calls modt which modifies the time in 24h format.
almm:	acall	modt		;call the modify time routine
	jnb	sdv,almmx1	;switches not valid so exit
	mov	a,r6		;get the switch data
	jz	almmx
	jnb	acc.0,almmx0	;jump if button 4 pressed
	jb	dmod,almme	;jump to enter new alarm data
	clr	xmode
	mov	r5,#00h		;lcd = time  led = seconds
	sjmp	almmx0		;jump so only 1 press detected
almmx:	mov	r6,#00h		;zero the switch data
almmx0:	clr	sdv		;zero the key valid flag
	mov	keycnt,#00h	;zero key counter
almmx1:	mov	r0,#mod1
	mov	r1,#tbuff+4
	acall	split		;splits packed bcd for display
	mov	r1,#tbuff+4
	mov	r2,#03
almm1:	mov	a,@r1		;get the number
	orl	a,#20h		;turn on colon
	mov	@r1,a		;save the number
	dec	r1		;point to the next
	djnz	r2,almm1	;do it three times
	ret			;return and display
almme:	mov	tbuff,#09h	;word address to 9
	mov	tbuff+1,#00	;hundredths to 0
	mov	tbuff+2,#00	;seconds to 0
	mov	tbuff+3,mod1	;minutes
	mov	tbuff+4,mod2	;hours
	setb	rs0		;select register bank 1
	mov	r2,#05h		;5 to send
	mov	r3,#00h
	mov	r4,#clock
	acall	iic		;to the clock
	clr	rs0		;select register bank 0
	mov	keycnt,#00h	;zero key counter only so no auto entry
	setb	aset		;turn on alarm bit
	clr	sdv		;clear key valid
	clr	xmode
	clr	dmod
	mov	r5,#00h		;lcd = time  led = seconds
	mov	tbuff,#08h	;alarm control register
	mov	tbuff+1,#alctl2	;get ready to turn alarm on
	setb	rs0		;select register bank 1
	mov	r2,#02
	mov	r3,#00
	mov	r4,#clock
	acall	iic		;send 2 bytes
	clr	rs0		;select register bank 0
	sjmp	almmx1
;
;
;DATP displays the current date or jumps to the date modify routine
datp:	jb	xmode,datm	;jump if bit set to date modify
;now get the data to work on
datp0:	mov	tbuff,#05h	;word address for date
	setb	rs0		;select register bank 1
	mov	r2,#01
	mov	r3,#02h		;read 2 bytes
	mov	r4,#clock
	acall	iic		;from the clock
	clr	rs0		;select register bank 0
	mov	dat2,tbuff
	mov	dat1,tbuff+1
;Check to see if button 4 has been pressed etc.
	jnb	sdv,datpd	;test for valid button, jump if not
	mov	a,r6		;get key data
	jnb	acc.3,datpd	;jump if not button 4
	clr	sdv		;zero flag so that only 1 keypress
	mov	keycnt,#00h	;zero input counter
	setb	xmode		;turn on mod bit
;Move the current date to the modify data area.
	mov	mod1,dat1
	mov	mod2,dat2
;now display the current date
datpd:	mov	r0,#dat1
	mov	r1,#tbuff+4
	acall	split		;get them ready for display
	orl	tbuff+3,#20h	;turn on colon 2
	ret			;return to display
;
;DATM modifies the date taking into account the variable number
;of days in each month.
datm:	acall	modd		;call the modify date routine
	jnb	sdv,datmx1	;switches not valid so exit
	mov	a,r6		;get the switch data
	jz	datmx
	jnb	acc.0,datmx0	;exit if button 1 not pressed
	jb	dmod,datme	;jump to enter new date data
	clr	xmode
	mov	r5,#00h		;lcd = time  led = seconds
	sjmp	datmx0
datmx:	mov	r6,#00h		;zero the switch data
datmx0:	clr	sdv		;zero the key valid flag
	mov	keycnt,#00h	;zero key counter
datmx1:	mov	r0,#mod1
	mov	r1,#tbuff+4
	acall	split		;splits packed bcd for display
	orl	tbuff+4,#20h	;turn on colon
	orl	tbuff+2,#20h	;turn on the other colon
	ret			;return and display
datme:	mov	tbuff,#05h	;word address to 5
	mov	tbuff+1,mod2
	mov	tbuff+2,mod1
	setb	rs0		;select register bank 1
	mov	r2,#03
	mov	r3,#00
	mov	r4,#clock
	acall	iic		;to the clock
	clr	rs0		;select register bank 0
	clr	sdv		;zero the key valid flag
	mov	keycnt,#00h	;zero key counter
	clr	xmode
	clr	dmod
	mov	r5,#00h		;lcd = time  led = seconds
	sjmp	datmx1
;
;MODT modifies the clock or alarm time stored in mod1 and mod2
;in keeping with the 24h format.
;mod1 contains the minutes and mod2 contains the hours
modt:	jnb	sdv,modtx1	;use switch data only if it is valid
	mov	a,r6		;get switch data
	jb	acc.2,modtm	;jump to modify minutes
	jb	acc.1,modth	;jump to modify hours
modtx:	mov	a,r6		;get the switch data
	anl	a,#00001001b	;mask out the bits we just used
	mov	r6,a
modtx1:	ret			;return to display
modtm:	setb	dmod		;set the modified bit
	mov	a,mod1		;get old minute data
	clr	c		;clear carry so da a works correctly
	add	a,#01h		;increment
	da	a		;but keep as bcd
	mov	mod1,a		;save new minute data
	clr	c		;clear the carry
	cpl	a		;1's complement
	add	a,#60h		;test for 60 minutes
	jc	modtx		;below 60 so exit
	mov	mod1,#00h	;else set minutes to zero
	sjmp	modtx
modth:	setb	dmod		;set the modified bit
	mov	a,mod2		;get old hour data
	clr	c		;clear the carry so da a works correctly
	add	a,#01h		;increment
	da	a		;but keep as bcd
	mov	mod2,a		;save new hour data
	clr	c		;clear the carry
	cpl	a		;1's complement
	add	a,#24h		;test for 24 hours
	jc	modtx		;below 24 so exit
	mov	mod2,#00h	;else set hour to zero
	sjmp	modtx
;
;MODD modifies the date.For simplicity it assumes every year is a
;leap year. With times and dates being modified for demonstrations
;this is not expected to be a problem.
modd:	jnb	sdv,moddx1	;no valid switch so jump
	mov	a,mod1		;get the current month
	mov	dptr,#month	;point into the table
	movc	a,@a+dptr	;get number of days + 1
	mov	r3,a		;save it
	mov	a,r6		;get the switch data
	jb	acc.1,moddd	;modify the date days
	jb	acc.2,moddm	;modify the date month
moddx:	mov	a,r6		;get the switch data
	anl	a,#00001001b	;mask out the bits we just used
	mov	r6,a
moddx1:	ret
moddd:	setb	dmod		;set the modified bit
	mov	a,mod2		;get the current number of days
	clr	c		;clear carry so da a works correctly
	add	a,#01		;increment
	da	a		;but keep as bcd
	mov	mod2,a		;save the new day
	clr	c		;clear the carry
	cpl	a		;1's complement
	add	a,r3		;compare with max
	jc	moddx		;below maximum so exit
	mov	mod2,#01	;else set to first of the month
	sjmp	moddx
moddm:	setb	dmod		;set the modified bit
	mov	a,mod1		;get the current month
	clr	c		;clear carry so da a works correctly
	add	a,#01		;increment
	da	a		;but keep as bcd
	mov	mod1,a		;save
	clr	c		;clear the carry
	cpl	a		;1's complement
	add	a,#13h		;test for month 13
	jc	moddm1		;below maximum so exit
	mov	mod1,#01	;else set to january
moddm1:	mov	a,mod1		;get the new month
	mov	dptr,#month	;point into the month table
	movc	a,@a+dptr	;get the new number of days
	mov	r3,a
	inc	r0		;so we point to the current day
	mov	a,@r0
	clr	c		;clear the carry
	cpl	a		;1's complement
	add	a,r3		;test if invalid number of days
	jc	moddx		;c=1 if accu < r3 so exit
	mov	mod1,#01		;else set to the first of the month
	sjmp	moddx
month:	db	00		;dummy
	db	32h		;january
	db	30h		;february (leap year)
	db	32h		;march
	db	31h		;april
	db	32h		;may
	db	31h		;june
	db	32h		;july
	db	32h		;august
	db	31h		;september
	db	00
	db	00
	db	00
	db	00
	db	00
	db	00
	db	32h		;october
	db	31h		;november
	db	32h		;december
;
endprg	equ	$
	if	endprg gt 2047
	HELP programme is too long !!!!
	endif
;
;
	end
